(*

                       Driver8 Realtime 3D Rendering Engine
            Copyright (c) 1997, Alex Chalfin. All Rights Reserved.
           DISTRIBUTION OF THIS SOURCE CODE IS STRICTLY PROHIBITED

*)

Unit Cull;
{$I DEFINE.INC}

Interface

Uses
  Types;

Procedure CullPolys(Var Obj : VectorObject; Var CullVector : Vertex3d);
Procedure ShadeXForm(Var View : ViewObject; Var Obj : VectorObject; M : Matrix4x3);

Implementation

Uses
  Clip,
  Shade,
  XForm;

{$L CULL.OBJ}
Procedure CullPolys(Var Obj : VectorObject; Var CullVector : Vertex3d); External;

Procedure ShadeXForm(Var View : ViewObject; Var Obj : VectorObject; M : Matrix4x3);

Var
  i : Longint;

Begin
  Shaders[Obj.RenderMask And SHADE_MASK](View, Obj, M);

  if ((Obj.RenderMask And SURFACE_MASK) = REFLECTION)
    Then ReflectionMap(View, Obj, M);

  TransForm(Obj, M);

  ClipPolygons(View, Obj);

  Project(View, Obj);

  for i := 0 to Obj.NumPoly - 1 do
    if (Obj.Polygons^[i].Visible = 1)
      Then AddPolygonToRenderList(@Obj.Polygons^[i], Obj.RenderMask);
End;

End.